//
//  ProfileSettingsViewController.swift
//  SuperSpaManagement
//
//  Created by PHAM ANH TUAN on 3/12/21.
//  Copyright (c) 2021 ___ORGANIZATIONNAME___. All rights reserved.
//
//  This file was generated by the 🐍 VIPER generator
//

import UIKit
import RxCocoa
import RxSwift
import RxDataSources

protocol ProfileSettingsPresenterInterface: PresenterInterface {
    var logoutTrigger: PublishRelay<Void> { get }
    var backTrigger: PublishRelay<Void> { get }
}


final class ProfileSettingsViewController: UIViewController, ProfileSettingsViewInterface {

    // MARK: - Public properties -

    let viewModels = BehaviorRelay<[ProfileSettingsCellType]>(value: [])
    
    var presenter: ProfileSettingsPresenterInterface!
    // MARK: - Lifecycle -
    
    @IBOutlet weak private var tableView: UITableView!

    lazy var dataSource = makeDataSource()
    
    private let disposeBag = DisposeBag()
    private let viewDidLoadRelay = BehaviorRelay(value: false)
    
    override func viewDidLoad() {
        super.viewDidLoad()
        defer {
            viewDidLoadRelay.accept(true)
        }
        configureViews()
        configurePresenter()
    }
    
    override func viewWillAppear(_ animated: Bool) {
        super.viewWillAppear(animated)
        navigationItem.leftBarButtonItem = UIBarButtonItem(
            image: Asset.Icon.Common.icIosBack.image.color(Colors.ink500),
            style: .plain,
            target: self,
            action: #selector(didTapBackBarButton)
        )
    }

    @objc private func didTapBackBarButton() {
        presenter.backTrigger.accept(())
    }
}

// MARK: - Extensions -

extension ProfileSettingsViewController {
    func configureViews() {
        configureTableView()
    }
    
    private func configureTableView() {

        view.backgroundColor = Colors.backgroundDark
        tableView.backgroundColor = UIColor.clear
        
        tableView.register(cellType: ProfileSettingsLogoutCell.self)
        
        tableView
            .rx
            .modelSelected(ProfileSettingsCellType.self)
            .subscribeNext { [weak self] selectedModelType in
                switch selectedModelType {
                case .logout:
                    self?.presenter.logoutTrigger.accept(())
                }
            }
            .disposed(by: disposeBag)
    }
}

extension ProfileSettingsViewController {
    private func configurePresenter() {
        let didLoad = viewDidLoadRelay.asObservable()
        viewModels
            .filterEmpty()
            .takeLatestWhen(didLoad)
            .map { [Section(model: 0, items: $0)] }
            .asDriver(onErrorDriveWith: .never())
            .drive(tableView.rx.items(dataSource: makeDataSource()))
            .disposed(by: disposeBag)
    }
}

enum ProfileSettingsCellType {
    case logout
}
extension ProfileSettingsViewController {
    typealias Section = SectionModel<Int, ProfileSettingsCellType>
    typealias DataSource = RxTableViewSectionedReloadDataSource<Section>
}

extension ProfileSettingsViewController {
    func makeDataSource() -> DataSource {
        return DataSource(
            configureCell: { (_, tableView, indexPath, model) -> UITableViewCell in
                switch model {
                case .logout:
                    let cell: ProfileSettingsLogoutCell = tableView.dequeueReusableCell(for: indexPath)
                    return cell
                }
            })
    }
    
}
